#ifndef _EMUOPTIONH
#define _EMUOPTIONH
/*  emuoption.c - get command line options, + misc ncurses functions
    (C) 2002-2004 The Linux Card Emulator Team

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    http://www.fsf.org/ */

#include <stdio.h>
#include "debug.h"

/* stored command line options */
enum { OPT_ERROR=1, OPT_HELP=2 , OPT_ERRDEV=4 };
typedef struct {
  short curses;
  short flags;
  short system;
  short logcard;
  short blind_logcard;
  short commlines;
  short conf_line[3];
  short data_files_RO;
  char *cfg_file;

  char *dev;
  int argc,argcp;
  char **argv;
  char *argvp;
  FILE *fdevout, *fdevin;
} comm_options_t;

extern comm_options_t comm_opt;

char *parse_command_line(int argc, char **argv);

/* console_getch() as scr_getch(), 
   but arguments from command line are sent first */
int console_getch() ;

void restore_inputmode() ;
void setup_inputmode();

enum { WINCOLOR_LOG=0, WINCOLOR_STAT=1, WINCOLOR_COMM=2 , WINCOLOR_MAX};
void wincolors_init();

#ifdef USE_NCURSES
/* color options etc. from config.dat and commandline */
typedef struct {
  int fcol, bcol;
  attr_t fattr, battr;
  short lines,y,conf_line;
  WINDOW **win;
} color_opt_t;

#else 
typedef struct {
  short conf_line;
} color_opt_t;
#endif
extern color_opt_t win_colors[];

void set_screen_colors(char **endptr, char *scrtype) ;
#endif
