#include <stdio.h>
#include <signal.h>
#include "debug.h"
#include "irdeto.h"
#include <string.h>
#include "config.h"
#include "confutil.h"
#include "emu_options.h"
#include "irdeto_v1_algorithm.h"
#include "newcamd-client.h"
#include "main.h"

unsigned short rcaid;
byte camkey[8];
int cchv1 = 0;

byte IrdetoATR[] = {0x3b, 0x9f, 0x21, 0x0e, 0x49, 0x52, 0x44, 0x45, 0x54, 0x4f,
                    0x20, 0x41, 0x43, 0x53, 0x20, 0x56, 0x31, 0x2e, 0x32, 0xa0};

static void send_buffer(int dbg, byte *buffer, int len)
{
  static byte status[] = {0x90, 0x00};
  byte cbyte = 0x3f;
  int i;
  
  for(i=0; i<len; i++)
   cbyte ^= buffer[i];
  
  sendbyte_n(dbg, buffer, 8);
  mlogprint(dbg," > ");
  if(len-8 > 0)
   sendbyte_n(dbg, buffer+8, len-8);
  sendbyte(dbg, cbyte);
  sendbyte_n(dbg, status, 2);
  mlogprint(dbg,"\n");
}

void read_FE(int dbg)
{
 byte resb,insfe[5];
 int  res;
 unsigned int counter=0;
 
 for(counter=0; counter< 5 ; counter++)
  {
	 res = readbyte(dbg);
   insfe[counter]= resb = (byte) res &0xff;
	 if(res< 0)
    {
	   msgprint("Error receiving INS[%d] (%d)\n",counter,res);
	   break;
	  }   
   }
   mlogprint(dbg,"\n");     
}

void DoIrdeto(byte *ins_all, byte dummy, byte cla, byte ins, byte p1, byte p2) 
{ 
  int i=0;
  byte incoming[0x100];
  byte len=p2;
  byte cwsbuf[0x100];
       
  int dbg;        
  logmasktp * logmaskp;    
  dbg=0x10;
  mlogtimestamp(dbg|DEB_ONLYLOG);
  logmaskp=find_logmask(& curr_CS->logmaskp, ins_all);
  if (logmaskp)  dbg |= logmaskp->debugval;
  mlogprint(dbg,"%02x%02x%02x%02x%02x",dummy,cla,ins,p1,p2);
  if (logmaskp)
   {
   mlogprint(dbg," %s\n",logmaskp->text);
   } 
   else 
   {
   mlogprint(dbg,"* undefined log message *\n");
   }
  
   sendbyte(dbg, cla);     //ack
   mlogprint(dbg,"\n");
   
                                         
   for(i=0; i<len; i++)    //read data to card
    {
     int a = readbyte(dbg);
     if(a<0)
      {
       mlogprint(1," ** Error receiving data ** \n");
       return;
      }
     incoming[i] = (byte)a;
    }
     mlogprint(dbg,"\n");
    
   switch(dummy)             
    {
      case 0xD2:        //init
  
       switch(cla)
       {
         case 0x42:
          {
           static byte len90[]     = {0x90, 0x19};
           static byte ins_reply[] = {0x01, 0x02, 0x00, 0x00, 0x21, 0x00, 0x00, 0x10,
                                      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
   
           sendbyte_n(dbg, len90, 2);
          mlogprint(1,"\n");
           
           read_FE(dbg);
           sendbyte(dbg, 0xFE);     //ack
          mlogprint(dbg,"\n");
           send_buffer(dbg, ins_reply, sizeof(ins_reply));
          mlogprint(dbg,"\n");
            }
           break;
           
         case 0x40:
          {
           static byte len90[]     = {0x90, 0x09};
           static byte ins_reply[] = {0x01, 0x02, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00};
           
           sendbyte_n(dbg, len90, 2);
           mlogprint(dbg,"\n");
           
           read_FE(dbg);
           sendbyte(dbg, 0xFE);     //ack
           mlogprint(dbg,"\n");
           send_buffer(dbg, ins_reply, sizeof(ins_reply));
           mlogprint(dbg,"\n");
            }
           break;
           
         case 0x3C:
          {
           static byte len90[]     = {0x90, 0x15};
           static byte ins_reply[] = {0x01, 0x02, 0x00, 0x00, 0x1E, 0x00, 0x00, 0x0C,
                                      0x60, 0x01, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00,
                                      0x00, 0x00, 0x00, 0x00};
  
           sendbyte_n(dbg, len90, 2);
           mlogprint(dbg,"\n");
           
           read_FE(dbg);
           sendbyte(dbg, 0xFE);     //ack
           mlogprint(dbg,"\n");
           send_buffer(dbg, ins_reply, sizeof(ins_reply));
           mlogprint(dbg,"\n");
            }
           break;
           
         case 0x3E:
          {
           static byte len90[]     = {0x90, 0x0B};
           static byte ins_reply[] = {0x01, 0x02, 0x00, 0x00, 0x1F, 0x00, 0x00, 0x02,
                                      0x01, 0x8D};
           
           sendbyte_n(dbg, len90, 2);
           mlogprint(dbg,"\n");
           
           read_FE(dbg);
           sendbyte(dbg, 0xFE);     //ack
           mlogprint(dbg,"\n");
           send_buffer(dbg, ins_reply, sizeof(ins_reply));
           mlogprint(dbg,"\n");
            }
           break;
         
         case 0x00:                          
          {
           static byte len90[]     = {0x90, 0x1D};
           static byte ins_reply[] = {0x01, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x14,
                                      0x31, 0x30, 0x35, 0x35, 0x35, 0x35, 0x35, 0x35,
                                      0x35, 0x30, 0x4F, 0x43, 0x53, 0x20, 0x31, 0x30,
                                      0x30, 0x31, 0x78, 0x20};
     
           sendbyte_n(dbg, len90, 2);
           mlogprint(dbg,"\n");
           
           read_FE(dbg);
           sendbyte(dbg, 0xFE);     //ack
           mlogprint(dbg,"\n");
           send_buffer(dbg, ins_reply, sizeof(ins_reply));
           mlogprint(dbg,"\n");
            }
           break;
         
         case 0x02:                                
          {
           static byte len90[]     = {0x90, 0x19};
           static byte ins_reply[] = {0x01, 0x02, 0x00, 0x00, 0x01, 0x00, 0x00, 0x10,
                                      0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00,
                                      0x00, 0x00, 0x04, 0x00, 0x05, 0xC2, 0x1F, 0x16};
           
           sendbyte_n(dbg, len90, 2);
           mlogprint(dbg,"\n");
           
           read_FE(dbg);
           sendbyte(dbg, 0xFE);     //ack
           mlogprint(dbg,"\n");
           send_buffer(dbg, ins_reply, sizeof(ins_reply));
           mlogprint(dbg,"\n");
            }
           break;
           
         case 0x04:
          {
           static byte len90[]     = {0x90, 0x19};
           static byte ins_reply[] = {0x01, 0x02, 0x00, 0x00, 0x02, 0x00, 0x00, 0x10,
                                      0x00, 0x06, 0x00, 0x06, 0x23, 0x06, 0x24, 0x06,
                                      0x25, 0x06, 0x26, 0x00, 0x00, 0x53, 0x56, 0x4B};
         
           sendbyte_n(dbg, len90, 2);
           mlogprint(dbg,"\n");
           
           read_FE(dbg);
           sendbyte(dbg, 0xFE);     //ack
           mlogprint(dbg,"\n");
           send_buffer(dbg, ins_reply, sizeof(ins_reply));
           mlogprint(dbg,"\n");
            }
           break;
         
         case 0x10:
          {
           static byte len90[]     = {0x90, 0x49};
           static byte ins_reply[] = {0x01, 0x02, 0x00, 0x00, 0x08, 0x00, 0x00, 0x40, 0x31, 0x32, 0x34, 0x32, 0x39, 0x36, 0x39, 0x32,
                                      0x35, 0x36, 0x9F, 0x49, 0x5F, 0xCE, 0x8F, 0x1E, 0x81, 0x1B, 0x12, 0x6F, 0xA8, 0x93, 0x3D, 0x8D,
                                      0xDB, 0x64, 0x80, 0xA9, 0x3D, 0x43, 0xCF, 0xA7, 0x25, 0x5F, 0x00, 0x9E, 0x87, 0x58, 0x14, 0xBE,
                                      0xCF, 0x53, 0xDA, 0x76, 0x10, 0xD6, 0x75, 0xD2, 0x0E, 0xEB, 0xA8, 0xA2, 0x12, 0xF9, 0x07, 0x9C,
                                      0xBD, 0x1D, 0x2F, 0xAD, 0x65, 0x36, 0x2B, 0x42};
 
           sendbyte_n(dbg, len90, 2);
           mlogprint(dbg,"\n");
           
           read_FE(dbg);
           sendbyte(dbg, 0xFE);     //ack
           mlogprint(dbg,"\n");
           send_buffer(dbg, ins_reply, sizeof(ins_reply));
           mlogprint(dbg,"\n");
            }
           break;
           
         case 0x36:                //--------------------randIV------------------------//
          {
           static byte len90[]     = {0x90, 0x0D};
           static byte ins_reply[] = {0x01, 0x02, 0x00, 0x00, 0x1B, 0x04, 0x00, 0x04,
                                      0xD4,0x7E,0x0C,0xF8};                       
    /*       static byte ins_reply[] = {0x01, 0x02, 0x00, 0x00, 0x1B, 0x04, 0x00, 0x04,
                                      0x09,0xAF,0x78,0xC7};       */
         
           sendbyte_n(dbg, len90, 2);
           mlogprint(dbg,"\n");
           
           read_FE(dbg);
           sendbyte(dbg, 0xFE);     //ack
         mlogprint(dbg,"\n");
           send_buffer(dbg, ins_reply, sizeof(ins_reply));
         mlogprint(dbg,"\n");
            }
           break;
        
        case 0x1C:                //cardfiles
          {
           static byte len90[]      = {0x90, 0x49};
           static byte ins_reply1[] = {0x01,0x02,0x00,0x00,0x0E,0x02,0x00,0x40,
					                             0xCE,0x66,0x1D,0xD6,0x2A,0x41,0x08,0x9E,0x44,0xBC,0xD5,0xD6,0x1C,0x99,0xF2,0xE8,
                                       0x0F,0xEF,0xCE,0x06,0xCF,0xF5,0x2D,0x5B,0x1E,0x6F,0x6A,0x62,0x12,0x85,0x47,0x0F,
                                       0xBA,0xDE,0xB7,0x15,0x98,0x2F,0x4C,0xE5,0x27,0x46,0x78,0xA6,0x0C,0x43,0x54,0x09,
                                       0xF0,0x1A,0xCC,0xB4,0x5B,0xD5,0xFA,0x69,0x06,0xE0,0x9F,0x54,0x0F,0xFE,0xC3,0x50};
          static byte ins_reply2[] =  {0x01,0x02,0x00,0x00,0x0E,0x03,0x00,0x40,
					                             0x74,0xCF,0x1F,0xC8,0x43,0x05,0x99,0xCF,0x7A,0xC4,0x65,0xB2,0xC3,0x0C,0x59,0xED,
                                       0x47,0x09,0x06,0xFF,0xD7,0x40,0x5B,0x54,0xB2,0xAA,0x3A,0x7B,0x63,0xFD,0xFA,0xA9,
                                       0xF2,0x7A,0xF6,0x2C,0x09,0xFD,0xD2,0x85,0x70,0x73,0x66,0xED,0x2A,0x60,0xE1,0x6C,
                                       0xD9,0x5E,0xB4,0x3B,0x6E,0xED,0x99,0x9D,0x62,0xB3,0xDA,0x24,0x6A,0xE1,0x00,0x88};                       
    
         
           sendbyte_n(dbg, len90, 2);
           mlogprint(dbg,"\n");
           
           read_FE(dbg);
           sendbyte(dbg, 0xFE);     //ack
          mlogprint(dbg,"\n");
           if (ins == 2)
            {
             send_buffer(dbg, ins_reply1, sizeof(ins_reply1));
            }
            else
            {
             send_buffer(dbg, ins_reply2, sizeof(ins_reply2));
            } 
          mlogprint(dbg,"\n");
            }
           break;
           
         case 0x2A:
          {
           static byte len90[]     = {0x90, 0x89};
           static byte ins_reply[] = {0x01,0x02,0x00,0x00,0x15,0x00,0x00,0x80,
                                     0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
                                     0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
                                     0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
                                     0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
                                     0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
                                     0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
                                     0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
                                     0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
        
           sendbyte_n(dbg, len90, 2);
           mlogprint(dbg,"\n");
           
           read_FE(dbg);
           sendbyte(dbg, 0xFE);     //ack
           mlogprint(dbg,"\n");
           send_buffer(dbg, ins_reply, sizeof(ins_reply));
           mlogprint(dbg,"\n");
            }
           break;
           
         case 0xA2:               
          {
           static byte len90[]     = {0x90, 0x09};
           static byte ins_reply[] = {0x01, 0x02, 0x00, 0x50, 0x51, 0x01, 0x03, 0x00};
         
           sendbyte_n(dbg, len90, 2);
           mlogprint(dbg,"\n");
           
           read_FE(dbg);
           sendbyte(dbg, 0xFE);     //ack
           mlogprint(dbg,"\n");
           send_buffer(dbg, ins_reply, sizeof(ins_reply));
           mlogprint(dbg,"\n");
            }
           break;
         
          case 0xA0:
          {
          // static byte len90[]     = {0x90, 0x09};
          // static byte ins_reply[] = {0x01, 0x02, 0x5F, 0x00, 0x50, 0x01, 0x00, 0x00};
           
           static byte len90[]     = {0x90, 0x19};
           static byte ins_reply[] = {0x01, 0x02, 0x5F, 0x00, 0x50, 0x01, 0x00, 0x10,  
                                      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,     
                                      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,};    
                                                                                          
  
           sendbyte_n(dbg, len90, 2);
           mlogprint(dbg,"\n");
           
           read_FE(dbg);
           sendbyte(dbg, 0xFE);     //ack
           mlogprint(dbg,"\n");
           send_buffer(dbg, ins_reply, sizeof(ins_reply));
           mlogprint(dbg,"\n");
            }
           break;
           
        case 0x50:
          {
          if (p2 == 0x01)        //check IPR layer
           {
           static byte len90[]     = {0x90, 0x09};
           static byte ins_reply[] = {0x01, 0x02, 0x00, 0x12, 0x28, 0x01, 0x00, 0x00};
         
           sendbyte_n(dbg, len90, 2);
           mlogprint(dbg,"\n");
           
           read_FE(dbg);
           sendbyte(dbg, 0xFE);     //ack
           mlogprint(dbg,"\n");
           send_buffer(dbg, ins_reply, sizeof(ins_reply));
           mlogprint(dbg,"\n");
           }
           else
           {
           static byte len90[]     = {0x90, 0x49};
           static byte ins_reply[] = {0x01, 0x02, 0x00, 0x00, 0x28, 0x01, 0x00, 0x40, 0x92, 0xF9, 0x21, 0x23, 0x58, 0xD8, 0x01, 0x70,
                                      0x47, 0xBA, 0x78, 0x29, 0x61, 0xD7, 0xAA, 0x30, 0xA2, 0xA1, 0x39, 0x1D, 0x01, 0xE0, 0xC7, 0x09,
                                      0x1E, 0x65, 0xA3, 0x1C, 0xEC, 0x44, 0x09, 0x1A, 0x6D, 0xB8, 0x48, 0x76, 0xB3, 0x9A, 0x72, 0xFF,
                                      0xF1, 0xDA, 0xFC, 0x4C, 0xA6, 0x29, 0x38, 0x0B, 0x95, 0x75, 0x5A, 0x7E, 0x4F, 0x83, 0x37, 0xA8,
                                      0x89, 0xE7, 0xD5, 0x1A, 0x21, 0xC4, 0x7E, 0x22};
          sendbyte_n(dbg, len90, 2);
           
/////////////---------------------camkey-------------------------///////////
    
/////////////---------------------camkey-------------------------///////////
           
          mlogprint(dbg,"\n");
          
           read_FE(dbg);
           sendbyte(dbg, 0xFE);     //ack
           mlogprint(dbg,"\n");
           send_buffer(dbg, ins_reply, sizeof(ins_reply));
           mlogprint(dbg,"\n");
           }
           cchv1 = 0;
          } 
           break;
           
        case 0x12:                  //CkeyCh_v1
          {
           static byte len90[]     = {0x90, 0x11};
           static byte ins_reply[] = {0x01, 0x02, 0x00, 0x00, 0x09, 0x03, 0x00, 0x08,     
                                      0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF}; 
                                                                                          
  
           sendbyte_n(dbg, len90, 2);
           
           memcpy(cwsbuf,incoming,64);
           Ird_RSA(cwsbuf);
           memcpy(camkey,cwsbuf + 8, 8);           //camkey
          mlogprint_buffer(dbg, cwsbuf, 0, 64, "\nencr    :");
          mlogprint_buffer(dbg, camkey, 0, 8, "\ncamkey  :");
           ir_CAMencrypt(cwsbuf + 24, camkey);     //helperkey
           memcpy(ins_reply + 8, cwsbuf +24, 8);
           
          mlogprint(dbg,"\n");
           
           read_FE(dbg);
           sendbyte(dbg, 0xFE);     //ack
          mlogprint(dbg,"\n");
           send_buffer(dbg, ins_reply, sizeof(ins_reply));
          mlogprint(dbg,"\n");
          
           cchv1 = 1;
           }
           break;
           
         case 0x06:
          {
           if(ins == 0x04)
           {
           static byte len90[]     = {0x90, 0x0B};
           static byte ins_reply[] = {0x01, 0x02, 0x00, 0x00, 0x03, 0x04, 0x00, 0x02,
                                      0xFF, 0xFF};
         
           sendbyte_n(dbg, len90, 2);
           mlogprint(dbg,"\n");
           
           read_FE(dbg);
           sendbyte(dbg, 0xFE);     //ack
           mlogprint(dbg,"\n");
           send_buffer(dbg, ins_reply, sizeof(ins_reply));
           mlogprint(dbg,"\n");
           }
           else
           if(p1 == 00)
           {
           static byte len90[]     = {0x90, 0x21};
           static byte ins_reply[] = {0x01, 0x02, 0x00, 0x00, 0x03, 0x00, 0x00, 0x18,
                                      0x00, 0x08, 0x95, 0xE0, 0x00, 0x00, 0x00, 0x00,
                                      0x00, 0x00, 0x1E, 0x08, 0x03, 0x00, 0x00, 0x00,
                                      0x00, 0x82, 0x62, 0x00, 0x00, 0x00, 0x00, 0x00};

           sendbyte_n(dbg, len90, 2);
           mlogprint(dbg,"\n");
           
           read_FE(dbg);
           sendbyte(dbg, 0xFE);     //ack
           mlogprint(dbg,"\n");
           send_buffer(dbg, ins_reply, sizeof(ins_reply));
           mlogprint(dbg,"\n");
           }
           if(p1 == 01)
           {
           static byte len90[]     = {0x90, 0x21};
           static byte ins_reply[] = {0x01, 0x02, 0x00, 0x00, 0x03, 0x00, 0x01, 0x18,
                                      0x01, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00,
                                      0x00, 0x00, 0x1E, 0x08, 0x00, 0x00, 0x00, 0x00,
                                      0x00, 0x82, 0x62, 0x00, 0x00, 0x00, 0x00, 0x00};
     
           sendbyte_n(dbg, len90, 2);
           mlogprint(dbg,"\n");
           
           read_FE(dbg);
           sendbyte(dbg, 0xFE);     //ack
           mlogprint(dbg,"\n");
           send_buffer(dbg, ins_reply, sizeof(ins_reply));
           mlogprint(dbg,"\n");
           }
           if(p1 == 02)
           {
           static byte len90[]     = {0x90, 0x21};
           static byte ins_reply[] = {0x01, 0x02, 0x00, 0x00, 0x03, 0x00, 0x02, 0x18,
                                      0x02, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00,
                                      0x00, 0x00, 0x1E, 0x08, 0x00, 0x00, 0x00, 0x00,
                                      0x00, 0x82, 0x62, 0x00, 0x00, 0x00, 0x00, 0x00};
         
           sendbyte_n(dbg, len90, 2);
           mlogprint(dbg,"\n");
           
           read_FE(dbg);
           sendbyte(dbg, 0xFE);     //ack
           mlogprint(dbg,"\n");
           send_buffer(dbg, ins_reply, sizeof(ins_reply));
           mlogprint(dbg,"\n");
           }
           if(p1 == 03)
           {
           static byte len90[]     = {0x90, 0x21};
           static byte ins_reply[] = {0x01, 0x02, 0x00, 0x00, 0x03, 0x00, 0x03, 0x18,
                                      0x03, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00,
                                      0x00, 0x00, 0x1E, 0x08, 0x00, 0x00, 0x00, 0x00,
                                      0x00, 0x82, 0x62, 0x00, 0x00, 0x00, 0x00, 0x00};
         
           sendbyte_n(dbg, len90, 2);
           mlogprint(dbg,"\n");
           
           read_FE(dbg);
           sendbyte(dbg, 0xFE);     //ack
           mlogprint(dbg,"\n");
           send_buffer(dbg, ins_reply, sizeof(ins_reply));
           mlogprint(dbg,"\n");
           }
          }
           break;
           
         case 0x38:
          {
           static byte len90[]     = {0x90, 0x10};
           static byte ins_reply[] = {0x01, 0x02, 0x00, 0x00, 0x1C, 0x00, 0x00, 0x07,
                                      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
    
           sendbyte_n(dbg, len90, 2);
           mlogprint(dbg,"\n");
           
           read_FE(dbg);
           sendbyte(dbg, 0xFE);     //ack
           mlogprint(dbg,"\n");
           send_buffer(dbg, ins_reply, sizeof(ins_reply));
           mlogprint(dbg,"\n");
            }
           break;
           
         case 0x54:
          {
           static byte len90[]     = {0x90, 0x09};
           static byte ins_reply[] = {0x01, 0x02, 0x00, 0x00, 0x2A, 0x01, 0x00, 0x00};
         
           sendbyte_n(dbg, len90, 2);
           mlogprint(dbg,"\n");
           
           read_FE(dbg);
           sendbyte(dbg, 0xFE);     //ack
           mlogprint(dbg,"\n");
           send_buffer(dbg, ins_reply, sizeof(ins_reply));
           mlogprint(dbg,"\n");
            }
           break;
         
         case 0x08:
          {
           static byte len90[]       = {0x90, 0x45};
           static byte ins_reply[]   = {0x01, 0x02, 0x00, 0x00, 0x04, 0x00, 0x00, 0x3C, 0x03, 0xED, 0x2D, 0xE9, 0x2E, 0x00, 0xFF, 0xB0,       
                                        0x2D, 0xE9, 0x2E, 0x00, 0xFF, 0xE0, 0x2D, 0xE9, 0x2E, 0x00, 0x03, 0xE9, 0x2D, 0xE9, 0x2E, 0x00,
                                        0x03, 0xEA, 0x2D, 0xE9, 0x2E, 0x00, 0x03, 0xEB, 0x2D, 0xE9, 0x2E, 0x00, 0x03, 0xEC, 0x2D, 0xE9,
                                        0x2E, 0x00, 0x17, 0x72, 0x2D, 0xE9, 0x2E, 0x00, 0x7F, 0xFE, 0x2D, 0xE9, 0x2E, 0x00, 0x7F, 0xFD,
                                        0x2D, 0xE9, 0x2A, 0x00};
          static byte ins_reply_FF[] = {0x01, 0x02, 0x00, 0x00, 0x04, 0x00, 0x00, 0x3C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,            //cta_res[10] == 0xFF...ukoncenie
                                        0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
                                        0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
                                        0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
                                        0xFF, 0xFF, 0xFF, 0x0FF};                             
         
           sendbyte_n(dbg, len90, 2);
           mlogprint(dbg,"\n");
           
           read_FE(dbg);
           sendbyte(dbg, 0xFE);     //ack
           mlogprint(dbg,"\n");
           if (p1 == 0)
            {
             if (incoming[0] == 0)
             {
              send_buffer(0, ins_reply, sizeof(ins_reply));
             }
             else
             {
              send_buffer(0, ins_reply_FF, sizeof(ins_reply));
             }
            }
            else
            {
             send_buffer(0, ins_reply_FF, sizeof(ins_reply));
            } 
           mlogprint(dbg,"\n");
            }
           break;
        
        case 0x16:
          {
           static byte len90[]     = {0x90, 0x34};
           static byte ins_reply[] = {0x01, 0x02, 0x00, 0x00, 0x0B, 0x00, 0x00, 0x2B, 0x43, 0x5A, 0x45, 0x00, 0x62, 0x00, 0x82, 0x00,
                                      0x82, 0x00, 0x82, 0x00, 0x82, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                      0x00, 0x00, 0x00};
         
           sendbyte_n(dbg, len90, 2);
           mlogprint(dbg,"\n");
           
           read_FE(dbg);
           sendbyte(dbg, 0xFE);     //ack
           mlogprint(dbg,"\n");
           send_buffer(0, ins_reply, sizeof(ins_reply));
           mlogprint(dbg,"\n");
            }
           break;
           
           default:
           break;                                         
        }
        break;
        
        case 0xD1:                //EMM
        {
           static byte len90[]     = {0x90, 0x19};
           static byte ins_reply[] = {0x01, 0x01, 0x00, 0x00, 0x3F, 0x00, 0x00, 0x10,
                                      0x38, 0x03, 0x00, 0x00, 0x00 ,0x80, 0x00, 0x00,
                                      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 ,0x00};
           
           sendbyte_n(dbg, len90, 2);
          mlogprint(dbg,"\n");
           
           read_FE(dbg);
           sendbyte(dbg, 0xFE);     //ack
           mlogprint(dbg,"\n");
           send_buffer(dbg, ins_reply, sizeof(ins_reply));
          mlogprint(dbg,"\n");
        }
        break;
        
        case 0xD5:                //ECM
        {
           static byte len90[]     = {0x90, 0x1F};
           static byte ins_reply[] = {0x01, 0x05, 0x9D, 0x00, 0x38, 0x00, 0x02, 0x16, 
                                      0xFF, 0xFF, 0x00, 0x12, 0xFF, 0xFF, 0xC8, 0x46,
                                      0x23, 0xC9, 0x9D, 0xE5, 0x6F, 0x09, 0x64, 0xAC,
                                      0x20, 0xC5, 0x2B, 0xA1, 0xA1, 0xA1};
            sendbyte_n(dbg, len90, 2);
           mlogprint(dbg,"\n");
           
            read_FE(dbg);
            sendbyte(dbg, 0xFE);     //ack
           mlogprint(dbg,"\n");
                        
            int cwsbuf_len = 6;
              
              cwsbuf[0]=0x81;
              cwsbuf[1]=0x70;
              cwsbuf[2]=len+3;
              cwsbuf[3]=0x41;
              cwsbuf[4]=0x00;
              cwsbuf[5]=0x00;
              memcpy(cwsbuf+6,incoming,len);
              cwsbuf_len+=len;
            
           mlogprint_buffer(dbg, cwsbuf, 0,  cwsbuf_len, "\nCWSecm  :"); 
            newcamd_decode_ecm(rcaid, cwsbuf, cwsbuf_len, ins_reply+14, NULL);
           mlogprint_buffer(dbg, ins_reply+14, 0, 16, "\nCWS     :"); 
           
            ins_reply[5]  ^= 1;     //even/odd  ...nemusi byt
            ins_reply[11] ^= 1;     //even/odd  ...nemusi byt
           
           if (cchv1 == 1)       //Camkey_Challenge_v1
            {
           mlogprint(dbg,"\n\t- CAMencrypt 1. round -");
		    ir_CAMencrypt(ins_reply+14, camkey);
           mlogprint(dbg,"\n\t- CAMencrypt 2. round -");
		    ir_CAMencrypt(ins_reply+14+8, camkey);
           mlogprint_buffer(dbg, ins_reply+14, 0, 16, "\nCWS encrypt :");
           mlogprint(dbg,"\n\t- key send -\n");
            send_buffer(dbg, ins_reply, sizeof(ins_reply));
            }   
            else                 //L2b
            {    

            }
        }
        break;
     
        default:
        break;          
     }
}
