#ifndef NEWCAMD_CLIENT_H
#define NEWCAMD_CLIENT_H

typedef void (*newcamd_callback)(void);

/*
  Call this to try and decode and ECM using a card server. The ECM should be a "raw" ECM
  as it would have looked in the DVB stream starting with 80/81
   The function will return 0 if ECM could be decoded and plainwords will the contain the 
   16 bytes  
*/
int newcamd_decode_ecm(unsigned short caid, unsigned char *ecm, int length, unsigned char *plainwords, newcamd_callback callback);

/* This should be called once to read the config file and initialize connections to the servers 
   The function will return 0 on success
*/
int init_newcamd();

#endif
