/* serfunc.h     */
#ifndef _SERFUNC
/*  serfunc
      some demo functions to manipulate serial port and speed in linux
      probably kernel >= 2.2.x is needed
    Copyright (C) 2000 The Linux Card Emulator Team

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    http://www.fsf.org/
*/
#define _SERFUNC

#define MAX_PORTS 4
#include "common.h"

int initPort_season(unsigned char csize, unsigned char parity, unsigned char cstopb,
	      unsigned char byteconvention, int baud ) ;
  /* csize: 5/6/7/8 ; parity: 0=none, 1=odd, 2=even ; cstopb=1/2 */
int initPort_phoenix(unsigned char csize, unsigned char parity, unsigned char cstopb,
	      unsigned char byteconvention, int baud ) ;
  /* csize: 5/6/7/8 ; parity: 0=none, 1=odd, 2=even ; cstopb=1/2 */

void openPort_season(int comport, char *devname);
void openPort_phoenix(int comport, char *devname);
int readbyte_rx(int deb, int chkreset) ;
int sendbyte(int deb,int ch) ;
int sendbyte_n(int deb,byte *ch, int n) ;
int GetReset_x(int deb) ;
void serial_port_shutdown(int deb) ;
void set_logcard(int logcard);

void ToggleRTS(int deb);
int phoenix_reset(int deb);

int Procedure(unsigned char ins, int restLen);
int IsoRead(int deb, byte *ch);
int IsoWrite(int deb, byte *ch);

enum { SERDB_RD=2, SERDB_WR=4, SERDB_RDWR=8 } ;

#define readbyte(n) readbyte_rx(n,1|SERDB_RD)
#define GetReset() GetReset_x(0)

#endif


